/* Saved in UTF-8 codepage: Příliš žluťoučký kůň úpěl ďábelské ódy. ÷ × ¤
 * Check: «Stereotype», Section mark-§, Copyright-©, Alpha-α, Beta-β, Smile-☺
 */
package eu.pedu.b62_j14.c00_common;



public class Pythagoras
{
    //##############################################################################
//== MAIN METHOD ===============================================================

    /***************************************************************************
     * Metoda spouštějící celou aplikaci.
     *
     * @param args Parametry příkazového řádku
     */
    public static void mainB(String[] args)
    {
        for (int a = 3;   a < 10000;   a++) {
            int b = 2*a; {
                int a2 = a*a;
                int b2 = b*b;
                double c = Math.sqrt(a2 + b2);
                int   ic = (int)Math.round(c);
                int   c2 = ic*ic;
                if (Math.abs(c - ic) < 1e-12) {
                    System.out.printf("a=%d, b=%d, c=%d \n"
                        + "a^2+b^2-c^2 = %d + %d - %d = %d\n",
                          a, b, ic, a2, b2, c2, (a2+b2-c2));
                }
            }
        }
    }


    /***************************************************************************
     * Metoda spouštějící celou aplikaci.
     *
     * @param args Parametry příkazového řádku
     */
    public static void main(String[] args)
    {
        for (int a = 3;   a < 100;   a++) {
            for (int b = a;   b <= 100;   b++) {
                int a2 = a*a;
                int b2 = b*b;
                double c = Math.sqrt(a2 + b2);
                int   ic = (int)Math.round(c);
                int   c2 = ic*ic;
                if (Math.abs(c - ic) < 1e-12) {
                    System.out.printf("a=%d, b=%d, c=%d \n"
                        + "a^2+b^2-c^2 = %d + %d - %d = %d\n",
                          a, b, ic, a2, b2, c2, (a2+b2-c2));
                }
            }
        }
    }

    /***************************************************************************
     * @todo mname - Je třeba ještě doplnit komentář
     */
    public boolean isRight(double a, double b, double c, int ID)
    {
        double c2  = c * c;
        double dif = Math.abs((a*a + b*b - c2) / c2);
        if (dif > 1e-12) {
            System.out.printf(
                "\nVelikost odvěsen a přepony nesplňuje Pythagorovu větu:\n"
              + "   a=%g, b=%g, c=%g,\n"
              + "   a^2=%g, b^2=%g, c^2=%g,\n"
              + "   Relativní rozdíl = %g", a, b, c, a*a, b*b, c2, dif);
            return false;
        }
        return true;
    }

//    /***************************************************************************
//     * Metoda spouštějící celou aplikaci.
//     *
//     * @param args Parametry příkazového řádku
//     */
//    public static void main(String[] args)
//    {
//        for (int a = 3;   a < 100000;   a++) {
//            int a2 = a*a;
//            double c = Math.sqrt(a2 + a2);
//            int   ic = (int)Math.round(c);
//            int   c2 = ic*ic;
//            if (Math.abs(c - ic) < 1e-8) {
//                System.out.printf("a=%d, c=%d \n"
//                    + "a^2+a^2-c^2 = 2 * %d - %d = %d\n",
//                      a, ic, a2, c2, (a2+a2-c2));
//            }
//        }
//    }
}
