/* Saved in UTF-8 codepage: Příliš žluťoučký kůň úpěl ďábelské ódy. ÷ × ¤
 * Check: «Stereotype», Section mark-§, Copyright-©, Alpha-α, Beta-β, Smile-☺
 */
package eu.pedu.b62_j14.c00_common;

//env -class-path B62_Lib_Pkg.jar

import java.util.*;
import java.util.function.*;
import java.util.regex.*;
import eu.pedu.lib20s.canvas.*;
import eu.pedu.lib20s.geom.*;
import eu.pedu.lib20s.util.*;



/*******************************************************************************
 * Knihovní třída {@code Start_17} je ekvivalentem stejnojmenného
 * startovního skriptu.
 *
 * @author  Rudolf PECINOVSKÝ
 * @version 2020-Summer
 */
public class Start_17
{
//\CC== CLASS CONSTANTS (CONSTANT CLASS/STATIC ATTRIBUTES/FIELDS) ==============
//\CV== CLASS VARIABLES (VARIABLE CLASS/STATIC ATTRIBUTES/FIELDS) ==============



//##############################################################################
//\CI== CLASS (STATIC) INITIALIZER (CLASS CONSTRUCTOR) =========================
//\CF== CLASS (STATIC) FACTORY METHODS =========================================
//\CG== CLASS (STATIC) GETTERS AND SETTERS =====================================
//\CM== CLASS (STATIC) REMAINING NON-PRIVATE METHODS ===========================

/***************************************************************************
 * Klon metody ze standardní knihovny.
 *
 * @param obj Objekt, jehož textová podoba se má vytisknout
 */
public static
void println(Object obj)
{
    System.out.println(obj);
}


/***************************************************************************
 * Klon metody ze standardní knihovny.
 *
 * @param obj Objekt, jehož textová podoba se má vytisknout
 */
public static
void print(Object obj)
{
    System.out.print(obj);
}


/**************************************************************************
 * Převede obsah dvourozměrného pole na textový řetězec tak, že
 * na první řádek vypíše zadaný titulek
 * a na každý další pak jeden řádek pole uvozený indexem daného řádku.
 */
public static
String arr2toString(String title, Object[][] arr2)
{
    StringBuilder sb = new StringBuilder(title);
    int index = 0;
    for(Object[] row : arr2) {
        sb.append('\n');
        sb.append(String.format("%3d: ", index++));
        sb.append(Arrays.toString(row));
    }
    return sb.toString();
}



//\CP== CLASS (STATIC) PRIVATE AND AUXILIARY METHODS ===========================



//##############################################################################
//\IC== INSTANCE CONSTANTS (CONSTANT INSTANCE ATTRIBUTES/FIELDS) ===============
//\IV== INSTANCE VARIABLES (VARIABLE INSTANCE ATTRIBUTES/FIELDS) ===============



//##############################################################################
//\II== INSTANCE INITIALIZERS (CONSTRUCTORS) ===================================

    /***************************************************************************
     */
    private Start_17()
    {
    }



//\IA== INSTANCE ABSTRACT METHODS ==============================================
//\IG== INSTANCE GETTERS AND SETTERS ===========================================
//\IM== INSTANCE REMAINING NON-PRIVATE METHODS =================================
//\IP== INSTANCE PRIVATE AND AUXILIARY METHODS =================================



//##############################################################################
//\NT== NESTED DATA TYPES ======================================================
}
