/* The file is saved in UTF-8 codepage.
 * Check: «Stereotype», Section mark-§, Copyright-©, Alpha-α, Beta-β, Smile-☺
 */
package eu.pedu.b62_j14.c18_visibility.outside;



////////////////////////////////////////////////////////////////////////////////
//%P-  +++++ End of ignored starting text - place for imports ++++++++++++++++++

import eu.pedu.b62_j14.c18_visibility.Daughter;
import eu.pedu.b62_j14.c18_visibility.Granddaughter;
import eu.pedu.b62_j14.c18_visibility.Mother;
import static eu.pedu.b62_j14.c18_visibility.Reports.*;



/*******************************************************************************
 * Testovací třída {@code ProtectedMethodTest} definuje sadu jednotkových testů
 * demonstrujících chování chráněných (protected) metod.
 *
 * @author  Rudolf PECINOVSKÝ
 * @version 2020-Summer
 */
public class OutsidePackage extends Daughter
{
//== CONSTANT CLASS ATTRIBUTES =================================================
//== VARIABLE CLASS ATTRIBUTES =================================================

    /** Počet vytvořených instancí této třídy. */
    private static int created = 0;



//##############################################################################
//== STATIC INITIALIZER (CLASS CONSTRUCTOR) ====================================
//== CLASS GETTERS AND SETTERS =================================================
//== OTHER NON-PRIVATE CLASS METHODS ===========================================
//== PRIVATE AND AUXILIARY CLASS METHODS =======================================



//##############################################################################
//== CONSTANT INSTANCE ATTRIBUTES ==============================================

    /** Rodné číslo instance = pořadí jejího vzniku v rámci této třídy. */
    protected final String ID = "O"  + ++created + '-' + super.ID;



//== VARIABLE INSTANCE ATTRIBUTES ==============================================



//##############################################################################
//== CONSTRUCTORS AND FACTORY METHODS ==========================================

    /***************************************************************************
     *
     */
    public OutsidePackage()
    {
//        constructorReport(this, OutsidePackage.class);
    }



//== ABSTRACT METHODS ==========================================================
//== INSTANCE GETTERS AND SETTERS ==============================================
//== OTHER NON-PRIVATE INSTANCE METHODS ========================================

    /***************************************************************************
     * Test volání chráněných (protected) metod rodičovské třídy.
     */
    public void parentCall()
    {
        Mother        .protectedStatic(Mother        .class);
        Daughter      .protectedStatic(Daughter      .class);
        OutsidePackage.protectedStatic(OutsidePackage.class);
        Granddaughter .protectedStatic(Granddaughter .class);
        System.out.println();
        this                .protectedInstance();
        new OutsidePackage().protectedInstance();
//        new Daughter()      .protectedInstance();
//        new Mother()        .protectedInstance();
    }


    /***************************************************************************
     * Vrátí textový podpis instance, tj. její řetězcovou reprezentaci.
     *
     * @return Textová reprezentace (podpis) dané instance
     */
    @Override
    public String toString()
    {
        return getClass().getSimpleName() + "_" + ID
                                          + "(" + super.toString() + ")";
    }



//== PRIVATE AND AUXILIARY INSTANCE METHODS ====================================



//##############################################################################
//== NESTED DATA TYPES =========================================================



//##############################################################################
//== MAIN METHOD ===============================================================

    /***************************************************************************
     * Metoda spouštějící celou aplikaci.
     *
     * @param args Parametry příkazového řádku
     */
    public static void main(String[] args)
    {
        new OutsidePackage().parentCall();
    }
}
