package eu.pedu.b62_j14.c21_exceptions;

public class Exceptions
{
    /** Prapříčina vyhození výjimky. */
    void a() {
        throw new ArithmeticException("Prapříčina: metoda a()");
    }

    /** Metoda konvertuje zachycenou výjimku na jinou. */
    void b() {
        try {
            a();
        }
        catch (Exception e) {
            throw new IllegalStateException("Metoda b(), Zdroj = a()",e);
        }
    }

    /** Konvertuje zachycenou výjimku na univerzální nekontrolovanou. */
    void c() {
        try   {
            b();
        }
        catch (Exception e) {
            throw new RuntimeException("Metoda c(), odchyceno z b()",e);
        }
    }

    /** Hlavní metoda spouštějící celou aplikaci.
     * @param args Argumenty příkazového řádku  */
    public static void main(String[] args)
    {
        Exceptions inst = new Exceptions();
        inst.c();
    }
}
