/* The file is saved in UTF-8 codepage.
 * Check: «Stereotype», Section mark-§, Copyright-©, Alpha-α, Beta-β, Smile-☺
 */
package eu.pedu.b62_j14.c22_generics;



/*******************************************************************************
 * Třída {@code GenericCrate2Test} slouží k demonstraci toho,
 * jak se lze vyhnout varovným hlášením přestože nepoužijeme typové argumenty.
 *
 * @author  Rudolf PECINOVSKÝ
 * @version 2020-Summer
 */
public class GenericCrate2Test2
{
    @SuppressWarnings({"unchecked", "rawtypes"})
    public static void main(String[] args)
    {
        GenericCrate2<String, Integer> stringInteger;
        String string1, string2;
        int    int1;

        stringInteger = new GenericCrate2("Bez", "Kontroly");
        System.out.println("Proměnná stringInteger: " + stringInteger);

        string1 = stringInteger.getV1();
    //    int2    = stringInteger.getV2();  //Přeloží se, chyba přijde za běhu
    //    string2 = stringInteger.getV2();  //Překladač neví, co tam je
        string2 = (String)(Object)stringInteger.getV2();
        System.out.println("Textové hodnoty: string1=" + string1 +
                                          ", string2=" + string2);

        GenericCrate2 gc = new GenericCrate2(1,2);
        System.out.println("gc - první pokus: " + gc);
        gc = new GenericCrate2<String, String>("Zcela", "bez kontroly");
        System.out.println("gc - druhý pokus: " + gc);

    //    string1 = gc.getV1();
        string1 = (String)gc.getV1();
    //    int1    = (int)   gc.getV2(); //Přeloží se, chyba přijde za běhu
        string2 = (String)gc.getV2();   //Netřeba už přes přetypování na Object
        System.out.println("Textové hodnoty: string1=" + string1 +
                           ", string2=" + string2);

        stringInteger = gc; //Projde, i když v něm může být cokoliv
                            //Chyby se začnou projevovat až za běhu
        System.out.println("Proměnná stringInteger: " + stringInteger);

        //Nejsou-li v deklaraci zadané typové argumenty, mohu zadat cokoliv
        gc = new GenericCrate2<String, GenericCrate2<String, Integer>>(
                                                  "Složená", stringInteger);
        System.out.println("Proměnná gc: " + gc);
    }
}
