/* UTF-8 codepage: Příliš žluťoučký kůň úpěl ďábelské ódy. ÷ × ¤
 * «Stereotype», Section mark-§, Copyright-©, Alpha-α, Beta-β, Smile-☺
 */
package eu.pedu.b62_j14.c22_generics;



/*******************************************************************************
 * Třída {@code ObjectCrate2Test} slouží k otestování vlastností třídy
 * {@link ObjectCrate2}.
 *
 * @author  Rudolf PECINOVSKÝ
 * @version 2020-Summer
 */
class ObjectCrate2Test
{
    public static void main(String[] args)
    {
        ObjectCrate2 stringInteger;
        ObjectCrate2 integerString;

        //Autoboxing převede int na Integer
        stringInteger = new ObjectCrate2("První", 1);
        integerString = new ObjectCrate2(2, "Druhý");
//        stringInteger = new ObjectCrate2(1, "První");  //Špatné pořadí typů
//        integerString = new ObjectCrate2("Druhý", 2);  //Špatné pořadí typů
        System.out.println("Vytvořeny přepravky:\n  " + stringInteger +
                                               "\n  " + integerString);

        String string1, string2;
        string1 = (String)stringInteger.getV1();
        string2 = (String)integerString.getV2();
//        string1 = (String)stringInteger.getV2();//Špatný typ návratové hodnoty
//        string2 = (String)integerString.getV1();//Špatný typ návratové hodnoty
        System.out.println("Textové hodnoty: string1=" + string1 +
                                          ", string2=" + string2);

        int int1, int2;    //Autounboxing převede Integer na int
        int1 = (int)stringInteger.getV2();
        int2 = (int)integerString.getV1();
//        int1 = (int)stringInteger.getV1();   //Špatný typ návratové hodnoty
//        int2 = (int)integerString.getV2();   //Špatný typ návratové hodnoty
        System.out.println("Celočíselné hodnoty: int1=" + int1 +
                                              ", int2=" + int2);

        //Součástí obecné přepravky může být cokoliv - třeba další přepravky
        ObjectCrate2
            composite = new ObjectCrate2(stringInteger, integerString);
        System.out.println("Složenina:\n  " + composite);
    }
}
