/* UTF-8 codepage: Příliš žluťoučký kůň úpěl ďábelské ódy. ÷ × ¤
 * «Stereotype», Section mark-§, Copyright-©, Alpha-α, Beta-β, Smile-☺
 */
package eu.pedu.b62_j14.c28_annotations;

import java.util.List;



@A1( "Anotace třídy" )
public class Annotated
{
    @A1( "Anotace atributu" )  String atribut = "Atribut";

    @A1( "Anotace konstruktoru" )
    public Annotated()
    {
    }
    @A1( "Anotace metody" )
    //Takto se dříve obcházela nemožnost zadat jednu anotaci vícekrát
    @AA1( {@A1("String lp"), @A1("int číslo")} )
    public void metoda(Annotated this,
                       @A2(text="parametr int i",číslo=1) int i,
                       @A2(text="parametr String s", číslo=2) String s )
    {
        @A2(text="lokální String lp",číslo=1) String lp = "Lokální proměnná";
        @A2(text="lokální int číslo",číslo=2) int číslo = -99;
    }

    @A1( "Anotace vnořeného interfejsu" )
    interface Rozhraní
    {
        @A1( "Metoda vnořeného interfejsu ")
        void metoda();
    }

    @A1( "Anotace vnořeného výčtového typu" )
    enum Kvalita
    {
        @A1( "Konstanta výčtového typu") DOBRÁ,
        @A1( "Konstanta výčtového typu") ŠPATNÁ;
    }

    class Inner
    {
        Inner(Annotated Annotated.this)
        {
        }

    }

    @SuppressWarnings("unchecked")
    public void mtd(List<String>... lists){}
}
