/* UTF-8 codepage: Příliš žluťoučký kůň úpěl ďábelské ódy. ÷ × ¤
 * «Stereotype», Section mark-§, Copyright-©, Alpha-α, Beta-β, Smile-☺
 */
package eu.pedu.b62_j14.c22_generics;



public class InstanceOf {

    public static <T extends Comparable<T>> void whoAmI( T a ) {
        System.out.println("Object: "     + (a instanceof Object) );
        System.out.println("Comparable: " + (a instanceof Comparable) );
        System.out.println("Double: "     + (a instanceof Double) );
        System.out.println("Double 0:   " + ((Object)a instanceof Double) );
        System.out.println("Double 1: "   + (a.getClass() == Double.class) );
        System.out.println("Double 2: "   + (Double.class.isInstance(a)) );
    }

//found   : T
//required: java.lang.Double
//        System.out.println("Double: " + (a instanceof Double) );
//1 error

    public static void list( Object a ) {
        System.out.println("Object: " + (a instanceof Object) );
        System.out.println("Comparable: " + (a instanceof Comparable) );
        System.out.println("Double: " + (a instanceof Double) );
    }
}
