/* Saved in UTF-8 codepage: Příliš žluťoučký kůň úpěl ďábelské ódy. ÷ × ¤
 * Check: «Stereotype», Section mark-§, Copyright-©, Alpha-α, Beta-β, Smile-☺
 */
package eu.pedu.b62_j14.c23_typearguments;

import java.io.Serializable;

/***************************************************************************
 * Generická třída s typovými parametry se dvěma omezeními.
 */
class Erasure_Before <CS extends Comparable<CS> & Serializable,
                      SC extends Serializable & Comparable<SC>>
{
    CS cs;
    SC sc;
    void modifyCS( CS p ) { if(cs.compareTo(p) < 0)  cs = p; }
    void modifySC( SC p ) { if(sc.compareTo(p) < 0)  sc = p; }
}

/***************************************************************************
 * Třída po zpětném překladu přeloženého kódu.
 */
@SuppressWarnings({"unchecked", "rawtypes"})
class Erasure_After
{
    Comparable   cs;
    Serializable sc;

    void modifyCS(Comparable p) {
        if(cs.compareTo((Object)p) < 0)  cs = p;
    }

    void modifySC(Serializable p) {
        if(((Comparable)sc).compareTo((Object)p) < 0)  sc = p;
    }
}
