/* UTF-8 codepage: Příliš žluťoučký kůň úpěl ďábelské ódy. ÷ × ¤
 * «Stereotype», Section mark-§, Copyright-©, Alpha-α, Beta-β, Smile-☺
 */
package eu.pedu.b62_j14.c23_typearguments;



public class IntervalC<T extends Comparable<T>>
{
    public final T lower, upper;

    public IntervalC(T lower, T upper)
    {
        this.lower = lower;
        this.upper = upper;
    }

    boolean inside(T value)
    {
        return (lower.compareTo(value) <= 0)  &&
               (upper.compareTo(value) >= 0);
    }
}
