/* UTF-8 codepage: Příliš žluťoučký kůň úpěl ďábelské ódy. ÷ × ¤
 * «Stereotype», Section mark-§, Copyright-©, Alpha-α, Beta-β, Smile-☺
 */
package eu.pedu.b62_j14.c24_nestedtypes;

import eu.pedu.b62_j14.c24_nestedtypes.SparseArray.Element;
import java.util.Iterator;

/****************************************************************************
 * Třída {@code SparseArrayTest} slouží k demonstraci použití
 * instancí třídy {@link SparseArray}.
 */
public class SparseArrayTest
{
    /** Vytvoří řídké pole a vytiskne jeho prvky.
     *  @param args Argumenty příkazového řádku  */
    public static void main(String[] args)
    {
        SparseArray sa = new SparseArray(0,10,0,0,40,0,0,0,80,0,0,110,0,130,0);
        for (Element e : sa) {
            System.out.println(e.index + ": " + e.value);
        }
        System.out.println("Použití standardního cyklu for");
        for (Iterator<Element> itel = sa.iterator();   itel.hasNext();   ) {
            Element e = itel.next();
            System.out.println(e.index + ": " + e.value);
        }
    }
}
