/* Saved in UTF-8 codepage: Příliš žluťoučký kůň úpěl ďábelské ódy. ÷ × ¤
 * Check: «Stereotype», Section mark-§, Copyright-©, Alpha-α, Beta-β, Smile-☺
 */
package eu.pedu.lib20s.canvas;

import eu.pedu.lib20s.geom.IShape;



/*******************************************************************************
 * Instance interfejsu {@code ICanvasShape} představují geometrické tvary,
 * které se umějí nakreslit na plátno a
 * které umějí prozradit a nastavit svoji pozici a svoje rozměry.
 * Pozice instance je implicitně definována jako pozice
 * levého horního rohu opsaného obdélníku.
 * Rozměry instance jsou přitom definovány jako rozměry opsaného obdélníku.
 * Interfejs nedeklaruje žádné nové abstraktní metody, všechny zdědí.
 *
 * @author  Rudolf PECINOVSKÝ
 * @version 2020-Summer
 */
public interface ICanvasShape
         extends IShape, ICanvasPaintable
{
//\CC== CLASS (STATIC) CONSTANTS ===============================================
//\CM== CLASS (STATIC) METHODS =================================================



//##############################################################################
//\AG== ABSTRACT GETTERS AND SETTERS ===========================================
//\AM== REMAINING ABSTRACT METHODS =============================================

    /***************************************************************************
     * Vrátí kopii daného tvaru, tj. stejný tvar
     * se stejnou velikostí, umístěním a barvou.
     *
     * @return Požadovaná kopie
     */
//    @Override
    public ICanvasShape copy();



//\DG== DEFAULT GETTERS AND SETTERS ============================================
//\DM== REMAINING DEFAULT METHODS ==============================================



//##############################################################################
//\NT== NESTED DATA TYPES ======================================================
}
